


***第一步：原始数据处理：以2015年数据为例
*** 2015年全国人口普查微观数据 ***
clear all
cd "C:\Users\Zhu CHEN\Desktop\b.用于生成文章图表的完整程序代码-20241023-22点"

clear
cap log close
log using "1日志文件-城市户籍开放度的计算.log", replace

use census2015.dta, clear
des, short

rename address dzid
tab cx
rename h3 htype  //户别：家庭户还是集体户
rename h4 huse    //住房类型（其他年份：住房用途）
rename h5  harea  //住房面积
rename h6 hroom  //住房间数
rename h7 hlayer   // 建筑层数
rename h8 hbuiltyear  //住宅建成时间
rename h9 hifkitch  //是否有厨房
rename h10 hiftoilet  //有无厕所
rename h11 hsource  //住房来源
rename h12 hcar     //拥有汽车情况

rename r2 relation  //与户主关系
rename r3 gender  //性别
tab age
rename r5 minzu  //民族
rename r6_1 hukou_reg1   //户口登记地情况1
rename r6_2 hukou_regid   //户口登记地省地县代码
rename r7_1 live
rename r7_2 liveplaceid
rename r8 liveyrs    //在本市居住时间

rename r9 leavetime    //离开户口登记地时间
rename r10 leavereason  //离开户口登记地原因
rename r11 hukou_typeifland   //是否有农村土地承包权（户口性质？）
rename r12_1 live_1yr  //一年前常住地
rename r12_2 live_prov1  //一年前常住地_省地码
rename r13_1 live_5yr  //五年前常住地
rename r13_2 live_prov5  //五年前常住地_省地码

rename r14 iflit  //是否识字
rename r15 educ  //受教育程度
rename r16 educ_status  //学业完成情况
rename r17 work  //上周工作情况
rename r18 industry  //行业
rename r19 occ       //职业
rename r20_1 workplace    //工作地点
rename r20_2 workplace_otherid    //其他代码
rename r21_1 commutetool    //通勤交通工具
rename r21_2 commutetime    //通勤时间
rename r22 notwork_reason  //未工作原因
rename r25 oldageins  //养老保险
rename r26 medicins  //医疗保险
rename r27 marriage  //婚姻状况
rename r28 ifcouple_single  //夫妇为独生子女情况
rename r29_1 ifbirth  //生育情况
rename r29_2 num_son   //生育儿子数量
rename r29_3 num_girl  //生育女儿数量
rename r29_4 num_son_live  //存活儿子数量
rename r29_5 num_girl_live  //存活女儿数量
***过去一年的生育情况
rename r30_1 ifbirth_ly  //过去1年生育情况
rename r30_2 birth1mth  //生育一孩时间_月
rename r30_3 bith1sex   //生育一孩性别
rename r30_4 birth2mth  //生育二孩时间_月
rename r30_5 birth2sex  //生育二孩婴儿性别
rename r31 living_60old
rename r32 health_60old
destring dzid, replace
destring   , replace
gen suryear=2015
save cens2015-hkopen.dta, replace



*** 第二步：存量流动流动人口的计算 ***
use cens2015-hkopen.dta, clear
bysort h1: gen hrenshu=_N
tab cx
*只保留城区和镇的
drop if cx==3

*对地址代码的调整
rename live_prov5 live_5yrid
rename live_prov1 live_1yrid
rename liveplaceid livenowid
*当现住地、五年前常住地、一年前常住地的代码只有两位的时候，假设都在省会
replace livenowid=livenowid*100+1    if livenowid<100  //假设在省会
tab live_1yrid
replace live_1yrid=live_1yrid*100+1  if live_1yrid<100  //假设在省会
tab live_5yrid
replace live_5yrid=live_5yrid*100+1  if live_5yrid<100  //假设在省会
foreach k in dzid hukou_regid live_5yrid live_1yrid livenowid {
	***北京
	replace `k'=1101 if int(`k'/100)==11
	***天津
	replace `k'=1201 if int(`k'/100)==12
	***上海
	replace `k'=3101 if int(`k'/100)==31
	***重庆
	replace `k'=5001 if int(`k'/100)==50
}
rename dzid dzid2015
merge n:1 dzid2015 using 2015年-4位数行政区划代码-已统一-历年原始代码来自民政部.dta, force

keep if _merge==3
drop _merge


*1.限定年龄为15-64岁
rename age age1
drop if age1==.
replace age1=100 if age1>=100
keep if inrange(age1,15,64)

*2.只保留流动原因是务工、工作、经商、拆迁搬家的、缺失的（代表没有离开户籍地）
tab leavereason
keep if inlist(leavereason,1,4,5,.)  //只分析迁移原因是务工或者经商，拆迁搬家的,缺失的（代表没有离开户籍地）

* 3. 删除五年前常住地在我国大陆以外地方的： “香港”、“澳门”、“台湾”或“国外”；删除户口待定的。
	/*
	duplicates drop live_5yrid,force
	sort live_5yrid
	五年前居住在我国大陆以外地方的
	可在地址栏中选择“香港”、“澳门”、“台湾”或“国外”。
	71 台湾
	81 香港
	82 澳门
	91 国外
	*/
drop if inlist(live_5yrid,71,81,82,91)

*4. 删除户口待定的
drop if inlist(hukou_reg1,3)

*5.删除学业完成情况是“在校学习”的
codebook  educ_status
drop if  educ_status==1 //删除在校的

****************
*Mct. 市内农业流动人口 + 跨市流动人口 
order dzid hukou_reg1 hukou_regid live_*yr* livenowid hukou_typeifland leavetime
tab hukou_reg1
replace hukou_reg1=1 if hukou_reg1==2 & hukou_regid==dzid  //虽然户口登记地不是本户现住房，但户口登记地与现住房在同一城市（4位代码）
keep if (hukou_reg1==1 & hukou_typeifland==1 & inlist(leavetime,3,4,5,6,7,8,9)) | ///
		(hukou_reg1==2 & inlist(leavetime,3,4,5,6,7,8,9)) 

*计算分母：各城市所有存量流动人口
tab hukou_reg1
bysort dzid2015: gen migt1=_N*1000


****************
*Qct.
*liveyrs 问题8，在本市居住时间
*本题仅要求设区地级市中的跨市外来人口或直辖市中的跨省外来人口填报。
drop liveyrs //删除居住年限，因为这个问题仅针对跨市流动
tab leavetime
gen liveyrs=20 if leavetime==1  //从未离开
replace liveyrs=0 if leavetime==2
replace liveyrs=0.5 if leavetime==3
replace liveyrs=1 if leavetime==4
replace liveyrs=2 if leavetime==5
replace liveyrs=3 if leavetime==6 
replace liveyrs=4 if leavetime==7
replace liveyrs=5 if inlist(leavetime,8,9)
tab liveyrs


rename name2015 city
gen pottt=.

*一.积分落户的城市

*二.条件落户的城市
*1. 定性限制
**就业
codebook work
tab oldageins
gen     emp=0
replace emp=1 if inlist(work,1,2) 
//上周有工作，或者正在休假等。
/*
***注：在量化忽略社保的偏误时，采用如下代码
replace emp=1 if inlist(work,1,2) & inlist(oldageins,1,4)
*/

*合法稳定住所
codebook hsource
gen     house=1 if inlist(hsource,7)  //"有合法稳定住房-租其他房"
replace house=2 if inlist(hsource,6)  //"有合法稳定住房-租廉租房、公租房"
replace house=3 if inlist(hsource,5)  //"有合法稳定住房-产权-自建"
replace house=4 if inlist(hsource,1,2,3,4)  //"有合法稳定住房-产权-购买"
replace house=0 if inlist(hsource,8,.) //"无合法稳定住房"  其他或缺失
tab house

**双稳1：合法稳定就业+合法固定住所
gen     eh=0
replace eh=1 if emp==1 & inlist(house,1,2,3,4)
tab eh

*2. 定量限制
*就业年限
*居住年限。

*3. 人才（不限定年龄）
tab educ
codebook educ
replace educ=0 if educ==.
gen talent=0
replace talent=1 if inlist(educ,4)  //高中
replace talent=1.5 if inlist(educ,5)  //中专
replace talent=2 if inlist(educ,6)  //大专
replace talent=3 if inlist(educ,7)  //本科
replace talent=4 if inlist(educ,8)  //研究生
tab talent
rename educ educ_d
tab marriage

nmissing leavereason
tab leavereason, sort

rename hukou_typeifland hukou_type
keep cx prov dzid2015 hukou_regid hukou_reg1 city talent age1 liveyrs house work emp occ eh migt1 pottt* htype hukou_type harea gender live_1yr live_1yrid live_5yr live_5yrid hsource marriage  educ_d leavereason *ins* hrenshu
order cx prov dzid2015 hukou_regid hukou_reg1 city talent age1 liveyrs house work emp occ eh migt1 pottt* htype hukou_type harea gender live_1yr live_1yrid live_5yr live_5yrid hsource marriage  educ_d *ins*
compress
rename talent educ
gen provid=int(dzid2015/100)
gen hkprovid=int(hukou_regid/100)
replace hkprovid=provid if hkprovid==.
replace city="北京市" if prov=="北京"
replace city="天津市" if prov=="天津"
replace city="上海市" if prov=="上海"
replace city="重庆市" if prov=="重庆"
rename dzid2015 dzid
save 2015落户概率.dta, replace






*** 第三步：计算得到城市户籍开放度。
***(1)找出符合城市落户条件的样本，并计算其总数。积分落户政策就是实际的积分落户人数。
*下面，以北京市2016年、厦门市2018年和青岛市2018年的政策为例来说明
*关于这三个市的政策文件及内容，详见附录说明

***北京市，2016年
use 2015落户概率.dta, clear
*2016年，积分落户，6000人
keep if prov=="北京"
replace pottt=6000   //
gen hkprob=pottt/migt1*100
duplicates drop prov migt1 pottt* hkprob*, force
keep prov city dzid migt1 pottt* hkprob*
gen year=201608
save 2016北京市.dta, replace


***厦门市，2018年
clear
use 2015落户概率.dta, clear
*2019年
keep if ///
(emp==1 & educ>=2 & city=="厦门市") | ///
(house>=3 & emp==1 & liveyrs>=5 & city=="厦门市") 
replace pottt=_N*1000
gen hkprob=pottt/migt1*100
duplicates drop city migt1 pottt* hkprob*, force
keep prov city dzid migt1 pottt* hkprob*
gen year=201809
save 2019厦门市.dta, replace




***青岛市，2018年
clear
use 2015落户概率.dta, clear
*2018年
keep if city=="青岛市"
/*
duplicates drop cnty, force
*/
* replace cnty="即墨区" if cnty=="即墨市"
gen main=0 
replace main=2 if cx==1
replace main=1 if cx==1  // inlist(cnty,"黄岛区","即墨区")
keep if ///
(educ>=4 & age1<=50 & city=="青岛市" & main==2) | ///
(educ>=3 & age1<=45 & city=="青岛市" & main==2) | ///
(emp==1 & educ>=2 & age1<=40 & city=="青岛市" & main==2) | ///
(emp==1 & liveyrs>=2 & educ>=1 & age1<=35 & city=="青岛市" & main==2) | ///
(house>=3 & harea>=90 & city=="青岛市" & main==2) | ///
(emp==1 & educ>=2 & age1<=26 & city=="青岛市" & main==2) | ///
(emp==1 & educ>=3 & age1<=27 & city=="青岛市" & main==2) | ///
(emp==1 & educ>=4 & age1<=31 & city=="青岛市" & main==2) | ///
(house>=3 & harea>=60 & city=="青岛市" & main==1) | ///
(educ>=4 & age1<=50 & city=="青岛市" & main==1) | ///
(educ>=3 & age1<=45 & city=="青岛市" & main==1) | ///
(emp==1 & educ>=2 & age1<=40 & city=="青岛市" & main==1) | ///
(emp==1 & educ>=1 & age1<=35 & city=="青岛市" & main==1) | ///
(house>=3 & harea>=90 & city=="青岛市" & main==1) | ///
(emp==1 & educ>=2 & age1<=26 & city=="青岛市" & main==1) | ///
(emp==1 & educ>=3 & age1<=27 & city=="青岛市" & main==1) | ///
(emp==1 & educ>=4 & age1<=31 & city=="青岛市" & main==1) | ///
(house>=1 & city=="青岛市" & main==0) 
replace pottt=_N*1000 + 3655
gen hkprob=pottt/migt1*100
duplicates drop city migt1 pottt* hkprob*, force
keep prov city dzid migt1 pottt* hkprob*
gen year=201803
save 2018青岛市.dta, replace















*************************************************
*** 如果利用2015年数据且考虑社保 ***
***第一步：原始数据处理：以2015年数据为例
*** 2015年全国人口普查微观数据 ***


*** 第二步：存量流动流动人口的计算 ***
use cens2015-hkopen.dta, clear
bysort h1: gen hrenshu=_N
tab cx
*只保留城区和镇的
drop if cx==3

*对地址代码的调整
rename live_prov5 live_5yrid
rename live_prov1 live_1yrid
rename liveplaceid livenowid
*当现住地、五年前常住地、一年前常住地的代码只有两位的时候，假设都在省会
replace livenowid=livenowid*100+1    if livenowid<100  //假设在省会
tab live_1yrid
replace live_1yrid=live_1yrid*100+1  if live_1yrid<100  //假设在省会
tab live_5yrid
replace live_5yrid=live_5yrid*100+1  if live_5yrid<100  //假设在省会
foreach k in dzid hukou_regid live_5yrid live_1yrid livenowid {
	***北京
	replace `k'=1101 if int(`k'/100)==11
	***天津
	replace `k'=1201 if int(`k'/100)==12
	***上海
	replace `k'=3101 if int(`k'/100)==31
	***重庆
	replace `k'=5001 if int(`k'/100)==50
}
rename dzid dzid2015
merge n:1 dzid2015 using 2015年-4位数行政区划代码-已统一-历年原始代码来自民政部.dta, force

keep if _merge==3
drop _merge


*1.限定年龄为15-64岁
rename age age1
drop if age1==.
replace age1=100 if age1>=100
keep if inrange(age1,15,64)

*2.只保留流动原因是务工、工作、经商、拆迁搬家的、缺失的（代表没有离开户籍地）
tab leavereason
keep if inlist(leavereason,1,4,5,.)  //只分析迁移原因是务工或者经商，拆迁搬家的,缺失的（代表没有离开户籍地）

* 3. 删除五年前常住地在我国大陆以外地方的： “香港”、“澳门”、“台湾”或“国外”；删除户口待定的。
	/*
	duplicates drop live_5yrid,force
	sort live_5yrid
	五年前居住在我国大陆以外地方的
	可在地址栏中选择“香港”、“澳门”、“台湾”或“国外”。
	71 台湾
	81 香港
	82 澳门
	91 国外
	*/
drop if inlist(live_5yrid,71,81,82,91)

*4. 删除户口待定的
drop if inlist(hukou_reg1,3)

*5.删除学业完成情况是“在校学习”的
codebook  educ_status
drop if  educ_status==1 //删除在校的

****************
*Mct. 市内农业流动人口 + 跨市流动人口 
order dzid hukou_reg1 hukou_regid live_*yr* livenowid hukou_typeifland leavetime
tab hukou_reg1
replace hukou_reg1=1 if hukou_reg1==2 & hukou_regid==dzid  //虽然户口登记地不是本户现住房，但户口登记地与现住房在同一城市（4位代码）
keep if (hukou_reg1==1 & hukou_typeifland==1 & inlist(leavetime,3,4,5,6,7,8,9)) | ///
		(hukou_reg1==2 & inlist(leavetime,3,4,5,6,7,8,9)) 

*计算分母：各城市所有存量流动人口
tab hukou_reg1
bysort dzid2015: gen migt1=_N*1000


****************
*Qct.
*liveyrs 问题8，在本市居住时间
*本题仅要求设区地级市中的跨市外来人口或直辖市中的跨省外来人口填报。
drop liveyrs //删除居住年限，因为这个问题仅针对跨市流动
tab leavetime
gen liveyrs=20 if leavetime==1  //从未离开
replace liveyrs=0 if leavetime==2
replace liveyrs=0.5 if leavetime==3
replace liveyrs=1 if leavetime==4
replace liveyrs=2 if leavetime==5
replace liveyrs=3 if leavetime==6 
replace liveyrs=4 if leavetime==7
replace liveyrs=5 if inlist(leavetime,8,9)
tab liveyrs


rename name2015 city
gen pottt=.

*一.积分落户的城市

*二.条件落户的城市
*1. 定性限制
**就业
codebook work
tab oldageins
gen     emp=0
replace emp=1 if inlist(work,1,2) & inlist(oldageins,1,4)
//上周有工作，或者正在休假等。

*合法稳定住所
codebook hsource
gen     house=1 if inlist(hsource,7)  //"有合法稳定住房-租其他房"
replace house=2 if inlist(hsource,6)  //"有合法稳定住房-租廉租房、公租房"
replace house=3 if inlist(hsource,5)  //"有合法稳定住房-产权-自建"
replace house=4 if inlist(hsource,1,2,3,4)  //"有合法稳定住房-产权-购买"
replace house=0 if inlist(hsource,8,.) //"无合法稳定住房"  其他或缺失
tab house

**双稳1：合法稳定就业+合法固定住所
gen     eh=0
replace eh=1 if emp==1 & inlist(house,1,2,3,4)
tab eh

*2. 定量限制
*就业年限
*居住年限。

*3. 人才（不限定年龄）
tab educ
codebook educ
replace educ=0 if educ==.
gen talent=0
replace talent=1 if inlist(educ,4)  //高中
replace talent=1.5 if inlist(educ,5)  //中专
replace talent=2 if inlist(educ,6)  //大专
replace talent=3 if inlist(educ,7)  //本科
replace talent=4 if inlist(educ,8)  //研究生
tab talent
rename educ educ_d
tab marriage

nmissing leavereason
tab leavereason, sort

rename hukou_typeifland hukou_type
keep cx prov dzid2015 hukou_regid hukou_reg1 city talent age1 liveyrs house work emp occ eh migt1 pottt* htype hukou_type harea gender live_1yr live_1yrid live_5yr live_5yrid hsource marriage  educ_d leavereason *ins* hrenshu
order cx prov dzid2015 hukou_regid hukou_reg1 city talent age1 liveyrs house work emp occ eh migt1 pottt* htype hukou_type harea gender live_1yr live_1yrid live_5yr live_5yrid hsource marriage  educ_d *ins*
compress
rename talent educ
gen provid=int(dzid2015/100)
gen hkprovid=int(hukou_regid/100)
replace hkprovid=provid if hkprovid==.
replace city="北京市" if prov=="北京"
replace city="天津市" if prov=="天津"
replace city="上海市" if prov=="上海"
replace city="重庆市" if prov=="重庆"
rename dzid2015 dzid
save 2015落户概率-考虑社保-2015.dta, replace




*** 第三步：计算得到城市户籍开放度。
***(1)找出符合城市落户条件的样本，并计算其总数。积分落户政策就是实际的积分落户人数。
*下面，以北京市2016年、厦门市2018年和青岛市2018年的政策为例来说明
*关于这三个市的政策文件及内容，详见附录说明

***北京市，2016年
use 2015落户概率-考虑社保-2015.dta, clear
*2016年，积分落户，6000人
keep if prov=="北京"
replace pottt=6000   //??????
gen hkprob=pottt/migt1*100
duplicates drop prov migt1 pottt* hkprob*, force
keep prov city dzid migt1 pottt* hkprob*
gen year=201608
save 2016北京市-考虑社保-2015.dta, replace


***厦门市，2018年
clear
use 2015落户概率-考虑社保-2015.dta, clear
*2019年
keep if ///
(emp==1 & educ>=2 & city=="厦门市") | ///
(house>=3 & emp==1 & liveyrs>=5 & city=="厦门市") 
replace pottt=_N*1000
gen hkprob=pottt/migt1*100
duplicates drop city migt1 pottt* hkprob*, force
keep prov city dzid migt1 pottt* hkprob*
gen year=201809
save 2019厦门市-考虑社保-2015.dta, replace


***青岛市，2018年
clear
use 2015落户概率-考虑社保-2015.dta, clear
*2018年
keep if city=="青岛市"
/*
duplicates drop cnty, force
*/
* replace cnty="即墨区" if cnty=="即墨市"
gen main=0 
replace main=2 if cx==1
replace main=1 if cx==1  // inlist(cnty,"黄岛区","即墨区")
keep if ///
(educ>=4 & age1<=50 & city=="青岛市" & main==2) | ///
(educ>=3 & age1<=45 & city=="青岛市" & main==2) | ///
(emp==1 & educ>=2 & age1<=40 & city=="青岛市" & main==2) | ///
(emp==1 & liveyrs>=2 & educ>=1 & age1<=35 & city=="青岛市" & main==2) | ///
(house>=3 & harea>=90 & city=="青岛市" & main==2) | ///
(emp==1 & educ>=2 & age1<=26 & city=="青岛市" & main==2) | ///
(emp==1 & educ>=3 & age1<=27 & city=="青岛市" & main==2) | ///
(emp==1 & educ>=4 & age1<=31 & city=="青岛市" & main==2) | ///
(house>=3 & harea>=60 & city=="青岛市" & main==1) | ///
(educ>=4 & age1<=50 & city=="青岛市" & main==1) | ///
(educ>=3 & age1<=45 & city=="青岛市" & main==1) | ///
(emp==1 & educ>=2 & age1<=40 & city=="青岛市" & main==1) | ///
(emp==1 & educ>=1 & age1<=35 & city=="青岛市" & main==1) | ///
(house>=3 & harea>=90 & city=="青岛市" & main==1) | ///
(emp==1 & educ>=2 & age1<=26 & city=="青岛市" & main==1) | ///
(emp==1 & educ>=3 & age1<=27 & city=="青岛市" & main==1) | ///
(emp==1 & educ>=4 & age1<=31 & city=="青岛市" & main==1) | ///
(house>=1 & city=="青岛市" & main==0) 
replace pottt=_N*1000 + 3655
gen hkprob=pottt/migt1*100
duplicates drop city migt1 pottt* hkprob*, force
keep prov city dzid migt1 pottt* hkprob*
gen year=201803
save 2018青岛市-考虑社保-2015.dta, replace














































