
***动态演进和现状分析
clear all
cd "C:\Users\Zhu CHEN\Desktop\b.用于生成文章图表的完整程序代码-20241023-22点"

cap log close
log using "4日志文件-落户门槛的动态演进和2024年现状分析.log", replace



***图A1
clear all
use 原始数据4-落户门槛的动态演进和2024年现状分析.dta, clear
xtset dzid year

*（1）非普查年份的人口数线性插值。详见附录1的说明
bysort dzid: mipolate pop year, gen(line_pop)
drop pop
rename line_pop pop
keep dzid prov city year pop hkprob thrhd
order dzid city year *pop* hkprob
bysort dzid: replace pop=pop[_n-1] if pop==.
bysort dzid: replace pop=pop[_n+1] if pop==.
bysort dzid: replace pop=pop[_n+1] if pop==.
bysort dzid: replace pop=pop[_n+1] if pop==.
bysort dzid: replace pop=pop[_n+1] if pop==.
bysort dzid: replace pop=pop[_n+1] if pop==.
split prov,p("省" "市" "自治区" "壮族自治区" "维吾尔自治区" "回族自治区")
drop prov
rename prov1 prov
order prov

*（2）全国加权均值
bysort year: egen popsum1=sum(pop)
gen wt1=pop/popsum1
bysort year: egen hkprobmean1=sum(hkprob*wt1)  //加权均值
replace hkprobmean1=(int(hkprobmean1*10))/10
bysort year: egen thrhdmean1=sum(thrhd*wt1)  //加权均值
replace thrhdmean1=(int(thrhdmean1*10))/10

*（3）仅保留全国均值
keep if dzid==1101

***图A1
graph twoway ///
(scatter thrhdmean1 year, msym(d) connect(1) mlab(thrhdmean1) mlabsize(tiny) mlabpos(1)) ///
, xtitle("年份") ytitle("落户门槛值 (%)") legend(off) xlabel(1996(1)2024, angle(45) labsize(small)) ylabel(0(5)100,labsize(small)) graphregion(margin(r+5))






***图1
clear
use 原始数据4-落户门槛的动态演进和2024年现状分析-第一财经.dta, clear
tab rank1st
bysort rank1st year: egen avethrhd4=mean(thrhd)
order rank1st year avethrhd4

graph twoway ///
(scatter avethrhd4 year if rank1st=="一线", msym(O) connect(1)) ///
(scatter avethrhd4 year if rank1st=="新一线", msym(D) connect(1)) ///
(scatter avethrhd4 year if rank1st=="二线", msym(T) connect(1)) ///
(scatter avethrhd4 year if rank1st=="三线", msym(Oh) connect(1)) ///
(scatter avethrhd4 year if rank1st=="四线", msym(Dh) connect(1)) ///
(scatter avethrhd4 year if rank1st=="五线", msym(Th) connect(1)) ///
, xtitle("年份") ytitle("落户门槛值（%）") legend(label(1 "一线") label(2 "新一线") label(3 "二线") label(4 "三线")  label(5 "四线")  label(6 "五线") rows(2)) xlabel(1996(2)2024, angle(45) labsize(small)) ylabel(0(5)100,labsize(small))







***表2
*各类城市在2014年、2016年和2024年的城市户籍开放度的描述性统计
clear all
use 原始数据4-落户门槛的动态演进和2024年现状分析-第一财经.dta, clear
xtset dzid year
gen rankdum=0 if rank1st=="一线" 
replace rankdum=1 if rank1st=="新一线"
replace rankdum=2 if rank1st=="二线"
replace rankdum=3 if rank1st=="三线"
replace rankdum=4 if rank1st=="四线"
replace rankdum=5 if rank1st=="五线"
sort rankdum year
keep if inlist(year,2014,2016,2024)
bysort rankdum year: sum hkprob, d

***表2
*表2的Panel A
preserve
	keep if rankdum==0
	logout, save(户籍开放度-一线) word replace: tabstat hkprob , s(N mean sd min p25 med p75 max) c(s) f(%6.2f) by(year)
restore

*表2的Panel B
preserve
	keep if rankdum==1
	logout, save(户籍开放度-新一线) word replace: tabstat hkprob , s(N mean sd min p25 med p75 max) c(s) f(%6.2f) by(year)
restore

*表2的Panel C
preserve
	keep if rankdum==2
	logout, save(户籍开放度-二线) word replace: tabstat hkprob , s(N mean sd min p25 med p75 max) c(s) f(%6.2f) by(year)
restore

*表2的Panel D
preserve
	keep if rankdum==3
	logout, save(户籍开放度-三线) word replace: tabstat hkprob , s(N mean sd min p25 med p75 max) c(s) f(%6.2f) by(year)
restore

*表2的Panel E
preserve
	keep if rankdum==4
	logout, save(户籍开放度-四线) word replace: tabstat hkprob , s(N mean sd min p25 med p75 max) c(s) f(%6.2f) by(year)
restore

*表2的Panel F
preserve
	keep if rankdum==5
	logout, save(户籍开放度-五线) word replace: tabstat hkprob , s(N mean sd min p25 med p75 max) c(s) f(%6.2f) by(year)
restore

*表2的Panel G
logout, save(户籍开放度-全部城市) word replace: tabstat hkprob , s(N mean sd min p25 med p75 max) c(s) f(%6.2f) by(year)





***表A3
clear all
use 原始数据4-落户门槛的动态演进和2024年现状分析-第一财经.dta, clear
gen rankdum=0 if rank1st=="一线" 
replace rankdum=1 if rank1st=="新一线"
replace rankdum=2 if rank1st=="二线"
replace rankdum=3 if rank1st=="三线"
replace rankdum=4 if rank1st=="四线"
replace rankdum=5 if rank1st=="五线"
sort rankdum dzid year
keep if inlist(city,"广州","苏州","温州","鄂尔多斯","六安","玉林")
keep  dzid prov city year month hkprob
order dzid prov city year month hkprob
keep if year>=2016
drop if month==.   //删除没有政策的年月。积分落户取当年1月
list

*最后在表A3呈现在2016-2024年间，分别最接近2016年和2024年6月2日的两个政策时间点的户籍开放度和对应的政策










***现状分布和高门槛城市
***2024年各地户籍开放度
clear all
use 原始数据4-落户门槛的动态演进和2024年现状分析-第一财经.dta, clear
label var thrhd "城市落户门槛"
keep if year==2024



*表3
gen type2="50-100" if thrhd>=50
replace type2="20-50" if inrange(thrhd,20,50) 
replace type2="5-20" if inrange(thrhd,5,20)
replace type2="0-5" if inrange(thrhd,0,5)
replace type2="0" if thrhd==0
tab type2, sort



***表VI1
gen type_2015ins="50-100" if inrange(thrhd_2015ins,50,100) 
replace type_2015ins="20-50" if inrange(thrhd_2015ins,20,50) 
replace type_2015ins="5-20" if inrange(thrhd_2015ins,5,20)
replace type_2015ins="0-5" if inrange(thrhd_2015ins,0,5)
replace type_2015ins="0" if thrhd_2015ins==0
tab type_2015ins, sort
tab type_2015ins


***图2
preserve
	keep if thrhd>50
	graph bar thrhd,  ///
	over(city,sort(thrhd) label(angle(45) labsize(small))) stack ///
	ytitle("落户门槛值(%)") ylabel(0(10)100) ///
	blabel(bar,format(%4.2f) size(vsmall))
restore



***图VI2 
preserve
	keep if type_2015ins=="50-100"
	graph bar thrhd_2015ins,  ///
	over(city,sort(thrhd_2015ins) label(angle(45) labsize(vsmall))) stack ///
	ytitle("落户门槛值(%)") ylabel(0(10)100) 
restore



***表4:分省
gen 低门槛=0 
replace 低门槛=1 if thrhd<=20.0000
tab 低门槛
bysort prov: gen  地级市数量=_N
bysort prov: egen 低门槛地级市数量=sum(低门槛)
sort dzid
gen 低门槛地级市比例=低门槛地级市数量/地级市数量*100
replace 低门槛地级市比例=int(低门槛地级市比例*10)/10
gen provid=int(dzid/100)
keep  provid prov city thrhd 低门槛 地级市数量 低门槛*
order provid prov city thrhd 低门槛 地级市数量 低门槛*
sort 低门槛地级市比例 provid
order prov city thrhd
gen nonlow=地级市数量-低门槛地级市数量
label var nonlow "非低门槛城市数量"
order nonlow provid city thrhd
sort nonlow provid thrhd
sort provid

***全域低门槛
gen 类型="全域低门槛" if 低门槛地级市比例==100

***还存在一个城市未实现低门槛
replace 类型="还存在一个城市未实现低门槛" if nonlow==1

***还存在两个城市未实现低门槛
replace 类型="还存在两个城市未实现低门槛" if nonlow==2

***还存在八个城市未实现低门槛
replace 类型="还存在八个城市未实现低门槛" if nonlow==8

***全域还存在高门槛
replace 类型="全域还存在高门槛" if 地级市数量==1 & 低门槛地级市数量==0

keep if 类型=="全域低门槛" | 低门槛==0
duplicates drop prov if 类型=="全域低门槛", force
tab 类型
order prov provid city 类型
gsort 类型 provid -thrhd
































