






***计算：高门槛城市的GDP和人口占比
***表5
clear all
cd "C:\Users\Zhu CHEN\Desktop\b.用于生成文章图表的完整程序代码-20241023-22点"

cap log close
log using "5日志文件-高门槛城市的GDP和人口占比.log", replace

***表5：Panel A第2列。计算9个高门槛城市的GDP占比
use 原始数据5-高门槛城市的GDP占比.dta, clear
*(1)分组
gen g=0  //其他城市
replace g=1 if inlist(city,"北京","上海","广州","深圳") //前4个高门槛城市
replace g=1 if inlist(city,"天津","厦门","苏州","杭州","中山")  //后5个高门槛城市

*(2)仅保留全国和高门槛城市
keep if city=="全国" | g==1 
encode city, gen(citycode)
reshape long gdp, i(citycode) j(year)
sort g citycode year

*(3)计算高门槛城市的GDP总和
bysort g year: egen gdpgt=sum(gdp)

*(4)计算高门槛城市的GDP占全国GDP之比
duplicates drop g year, force
keep  g year gdpgt
order g year gdpgt
reshape wide gdpgt, i(year) j(g)
gen rate=int(gdpgt1/gdpgt0*100*100)/100
keep year rate
rename rate GDP占比
list







***表5：Panel B第2列。计算27个高门槛城市的GDP占比
*排除迪庆，因为CEIC中，2000迪庆的GDP数据缺失
clear
use 原始数据5-高门槛城市的GDP占比.dta, clear
*(1)分组
gen g=0
replace g=1 if inlist(city,"北京","上海","天津","广州","厦门","深圳","中山","泉州")
replace g=1 if inlist(city,"苏州","潮州","揭阳","杭州","珠海","长沙","三亚","惠州")
replace g=1 if inlist(city,"迪庆","成都","江门","佛山","温州","莆田","南京","东莞")
replace g=1 if inlist(city,"淮北","漳州","淮南","武汉")

*(2)仅保留全国和高门槛城市
keep if g==1 | city=="全国"
nmissing
* keep if inlist(city,"吐鲁番","昌都","林芝","儋州","三沙")
* drop if inlist(city,"吐鲁番","昌都","林芝","儋州","三沙")
drop if city=="迪庆"
encode city, gen(citycode)
reshape long gdp, i(citycode) j(year)
sort g citycode year

*(3)计算高门槛城市的GDP总和
bysort g year: egen gdpgt=sum(gdp)

*(4)计算高门槛城市的GDP占全国GDP之比
duplicates drop g year, force
keep  g year gdpgt
order g year gdpgt
reshape wide gdpgt, i(year) j(g)
gen rate=int(gdpgt1/gdpgt0*100*100)/100
keep year rate
rename rate GDP占比
list







***人口和流动人口数的占比
***表5：Panel A第3-第6列。计算9个高门槛城市的人口和流动人口数占比
clear 
use 原始数据5-高门槛城市的人口占比.dta, clear
bysort year: egen tpop=sum(pop)
bysort year: egen tmig1=sum(mig1)
bysort year: egen tmig2=sum(mig2)
bysort year: egen tmig3=sum(mig3)

*(1)分组
gen g=0
replace g=1 if inlist(city,"北京市","上海市","广州市","深圳市")
replace g=1 if inlist(city,"天津市","厦门市","苏州市","杭州市","中山市")
tab g

*(2)计算全国总数
bysort g year: egen tpopg=sum(pop)
bysort g year: egen tmig1g=sum(mig1)
bysort g year: egen tmig2g=sum(mig2)
bysort g year: egen tmig3g=sum(mig3)
duplicates drop g year, force
keep  g year t*g
reshape wide t*g, i(year) j(g)

*(3)计算高门槛城市的GDP占全国GDP之比
gen tpopratiog1=int((tpopg1/(tpopg1+tpopg0))*1000)/1000*100      //百分点数
gen tmig1ratiog1=int((tmig1g1/(tmig1g1+tmig1g0))*1000)/1000*100  //百分点数  
gen tmig2ratiog1=int((tmig2g1/(tmig2g1+tmig2g0))*1000)/1000*100  //百分点数
gen tmig3ratiog1=int((tmig3g1/(tmig3g1+tmig3g0))*1000)/1000*100  //百分点数
keep if inlist(year,2000,2010,2020)
order year *ratiog1
keep  year *ratiog1
rename tpopratiog1   总人口占比
rename tmig1ratiog1 本县市或本市市区迁入人口占比
rename tmig2ratiog1 本省其他县市或市区迁入人口占比
rename tmig3ratiog1 外省迁入人口占比
list



***28个城市
***表5：Panel B第3-第6列。计算27个高门槛城市的人口和流动人口数占比
*排除迪庆，因为CEIC中，2000迪庆的GDP数据缺失

clear
use 原始数据5-高门槛城市的人口占比.dta, clear
bysort year: egen tpop=sum(pop)
bysort year: egen tmig1=sum(mig1)
bysort year: egen tmig2=sum(mig2)
bysort year: egen tmig3=sum(mig3)

*(1)分组
gen g=0
replace g=1 if inlist(city,"北京市","上海市","天津市","广州市","厦门市","深圳市","中山市","泉州市")
replace g=1 if inlist(city,"苏州市","潮州市","揭阳市","杭州市","珠海市","长沙市","三亚市","惠州市")
replace g=1 if inlist(city,"迪庆藏族自治州","成都市","江门市","佛山市","温州市","莆田市","南京市","东莞市")
replace g=1 if inlist(city,"淮北市","漳州市","淮南市","武汉市")
tab g

*(2)计算全国总数
bysort g year: egen tpopg=sum(pop)
bysort g year: egen tmig1g=sum(mig1)
bysort g year: egen tmig2g=sum(mig2)
bysort g year: egen tmig3g=sum(mig3)
duplicates drop g year, force
keep  g year t*g
reshape wide t*g, i(year) j(g)

*(3)计算高门槛城市的GDP占全国GDP之比
gen tpopratiog1=int((tpopg1/(tpopg1+tpopg0))*1000)/1000*100  //百分点数
gen tmig1ratiog1=int((tmig1g1/(tmig1g1+tmig1g0))*1000)/1000*100  //百分点数  
gen tmig2ratiog1=int((tmig2g1/(tmig2g1+tmig2g0))*1000)/1000*100  //百分点数
gen tmig3ratiog1=int((tmig3g1/(tmig3g1+tmig3g0))*1000)/1000*100  //百分点数

keep if inlist(year,2000,2010,2020)
order year *ratiog1
keep  year *ratiog1
rename tpopratiog1   总人口占比
rename tmig1ratiog1 本县市或本市市区迁入人口占比
rename tmig2ratiog1 本省其他县市或市区迁入人口占比
rename tmig3ratiog1 外省迁入人口占比
list



log close































